import { Glue } from "../index";
import { ILogin, IUserWithToken } from "./interfaces";
import { IAuth, ILoginWithEmailPasswordArgs, ISignupWithEmail } from "./interfaces/IAuth";
import IAuthProviderEnum from "./interfaces/IAuthProviderEnum";
export declare class Auth implements IAuth {
    authBaseUrl: string;
    authToken: string;
    glue: Glue;
    constructor(AUTH_BASE_URL: string, GLUE: Glue, AUTH_TOKEN?: string);
    loginWithEmailPassword(args: ILoginWithEmailPasswordArgs): Promise<string | IUserWithToken>;
    socialSignup(provider: IAuthProviderEnum): Promise<string | IUserWithToken | null>;
    socialLogin(provider: IAuthProviderEnum): Promise<string | IUserWithToken | null>;
    signupWithEmail(args: ISignupWithEmail): Promise<string | IUserWithToken>;
    login(authObject: ILogin): Promise<string | IUserWithToken | null>;
    setAuthToken(_token: string): string;
    getAuthToken(): string;
    getUser(): Promise<any>;
    isLoggedIn(): Promise<boolean>;
}
